#include "utils_boost.hpp"
#include <stdexcept>

boost::filesystem::path CreateTemporaryDirectory(size_t retry)
{
    namespace fs = boost::filesystem;

    // システムのテンポラリディレクトリを取得
    auto system_temp_dir_path = fs::temp_directory_path();

    // 何回かテンポラリディレクトリ作成を試みる
    for (size_t i = 0; i < retry; ++i)
    {
        //system_temp_dir_path = fs::path("./tmp");
        auto dir_path = system_temp_dir_path / fs::unique_path();
        try
        {
            fs::create_directory(dir_path);
        }
        catch (const fs::filesystem_error& e)
        {
            if (e.code().value() != boost::system::errc::file_exists)
            {
                throw; // rethrow
            }
        }
        return dir_path;
    }

    throw std::runtime_error("couldn't create a temporary directory");
}

